zoukankan      html  css  js  c++  java
  • HDU 4283 You Are the One 区间DP

    You Are the One

    Time Limit: 20 Sec

    Memory Limit: 256 MB

    题目连接

    http://acm.hdu.edu.cn/showproblem.php?pid=4283

    Description

    The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

    Input

      The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
      The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

    Output

    For each test case, output the least summary of unhappiness .

    Sample Input

    2
      
    5
    1
    2
    3
    4
    5

    5
    5
    4
    3
    2
    2

    Sample Output

    Case #1: 20
    Case #2: 24

    HINT

    题意

    给你一列数,要求这些数利用栈生成一个序列,使得累加(i*a[i])的值最小

    题解:

    区间DP,详情看注释

    代码

    #include <stdio.h>
    #include <string.h>
    #include <algorithm>
    using namespace std;
    
    const int inf = 10000000;
    
    int n,a[105],sum[105],dp[105][105];
    
    int main()
    {
        int t,i,j,k,l,cas = 1;
        scanf("%d",&t);
        while(t--)
        {
            scanf("%d",&n);
            memset(sum,0,sizeof(sum));
            for(i = 1; i<=n; i++)
            {
                scanf("%d",&a[i]);
                sum[i] = sum[i-1]+a[i];
            }
            memset(dp,0,sizeof(dp));
            for(i = 1; i<=n; i++)
            {
                for(j = i+1; j<=n; j++)
                    dp[i][j] = inf;
            }
            for(l = 1; l<n; l++)
            {
                for(i = 1; i<=n-l; i++)
                {
                    j = i+l;
                    for(k = 1; k<=j-i+1; k++)
                        dp[i][j] = min(dp[i][j],dp[i+1][i+k-1]+dp[i+k][j]+k*(sum[j]-sum[i+k-1])+a[i]*(k-1));
                    /*
                    dp[i][j]表示从第i个人到第j个人这段区间的最小花费(是只考虑这j-i+1个人,不需要考虑前面有多少人)
                    那么对于dp[i][j]的第i个人,就有可能第1个上场,也可以第j-i+1个上场。考虑第K个上场
                    即在i+1之后的K-1个人是率先上场的,那么就出现了一个子问题 dp[i+1][i+k-1]表示在第i个人之前上场的
                    对于第i个人,由于是第k个上场的,那么屌丝值便是a[i]*(k-1)
                    其余的人是排在第k+1个之后出场的,也就是一个子问题dp[i+k][j],对于这个区间的人,由于排在第k+1个之后,所以整体愤怒值要加上k*(sum[j]-sum[i+k-1])
                    */
                }
            }
            printf("Case #%d: %d
    ",cas++,dp[1][n]);
        }
    
        return 0;
    }
  • 相关阅读:
    C连载20-转换说明中的异常
    Android连载30-SharedPreference存储
    搭建一个开源项目12-Kubernetes集群部署(下)以及elasticsearch部署
    JavaScript连载29-元素类型获取、节点CD
    从零开始学VUE之模板语法(计算属性)
    从零开始学VUE之模板语法(绑定属性)
    从零开始学VUE之模板语法(插值操作)
    从零开始学VUE之Vue的生命周期
    从零开始学VUE之Vue创建时可以传入的Option属性
    从零开始学VUE之Vuejs初体验(DEMO)
  • 原文地址:https://www.cnblogs.com/qscqesze/p/4662251.html
Copyright © 2011-2022 走看看